type token =
    ANNOT of (int * string)
  | WDECL of (int * string)
  | IDENTIFIER of (string)
  | CONSTANT of (string)
  | STRING_LITERAL of (string)
  | TYPE_NAME of (string)
  | SIZEOF
  | PTR_OP
  | INC_OP
  | DEC_OP
  | LEFT_OP
  | RIGHT_OP
  | LE_OP
  | GE_OP
  | EQ_OP
  | NE_OP
  | AND_OP
  | OR_OP
  | MUL_ASSIGN
  | DIV_ASSIGN
  | MOD_ASSIGN
  | ADD_ASSIGN
  | SUB_ASSIGN
  | LEFT_ASSIGN
  | RIGHT_ASSIGN
  | AND_ASSIGN
  | XOR_ASSIGN
  | OR_ASSIGN
  | TYPEDEF
  | EXTERN
  | STATIC
  | AUTO
  | REGISTER
  | CHAR
  | SHORT
  | INT
  | LONG
  | SIGNED
  | UNSIGNED
  | FLOAT
  | DOUBLE
  | CONST
  | VOLATILE
  | VOID
  | STRUCT
  | UNION
  | ENUM
  | ELLIPSIS
  | CASE
  | DEFAULT
  | IF
  | ELSE
  | SWITCH
  | WHILE
  | DO
  | FOR
  | GOTO
  | CONTINUE
  | BREAK
  | RETURN
  | SEMICOLON
  | LBRACE
  | RBRACE
  | COMMA
  | COLON
  | EQUAL
  | LPAR
  | RPAR
  | LSQUARE
  | RSQUARE
  | DOT
  | AMP
  | EXL
  | TILDE
  | MINUS
  | PLUS
  | STAR
  | SLASH
  | PERCENT
  | LT
  | GT
  | HAT
  | PIPE
  | QUESTION
  | EOF

open Parsing
# 20 "src/cparser.mly"

  open Logic
  open Ptree
  open Cast
  open Parsing

  let loc () = (symbol_start (), symbol_end ())
  let loc_i i = (rhs_start i, rhs_end i)

  let uns () =
    raise (Stdpp.Exc_located (loc (), Stream.Error "Unsupported C syntax"))
  let unss s =
    raise (Stdpp.Exc_located (loc (), 
			      Stream.Error ("Unsupported C syntax: " ^ s)))

  let add_pre_loc lb = function
    | Some (b,_) -> Loc.join (b,0) lb 
    | _ -> lb

  let expr_of_statement = function
    | CSnop l -> CEnop l
    | CSexpr (_, e) -> e
    | _ -> assert false

(* Line 28, file src/cparser.ml *)
let yytransl_const = [|
  263 (* SIZEOF *);
  264 (* PTR_OP *);
  265 (* INC_OP *);
  266 (* DEC_OP *);
  267 (* LEFT_OP *);
  268 (* RIGHT_OP *);
  269 (* LE_OP *);
  270 (* GE_OP *);
  271 (* EQ_OP *);
  272 (* NE_OP *);
  273 (* AND_OP *);
  274 (* OR_OP *);
  275 (* MUL_ASSIGN *);
  276 (* DIV_ASSIGN *);
  277 (* MOD_ASSIGN *);
  278 (* ADD_ASSIGN *);
  279 (* SUB_ASSIGN *);
  280 (* LEFT_ASSIGN *);
  281 (* RIGHT_ASSIGN *);
  282 (* AND_ASSIGN *);
  283 (* XOR_ASSIGN *);
  284 (* OR_ASSIGN *);
  285 (* TYPEDEF *);
  286 (* EXTERN *);
  287 (* STATIC *);
  288 (* AUTO *);
  289 (* REGISTER *);
  290 (* CHAR *);
  291 (* SHORT *);
  292 (* INT *);
  293 (* LONG *);
  294 (* SIGNED *);
  295 (* UNSIGNED *);
  296 (* FLOAT *);
  297 (* DOUBLE *);
  298 (* CONST *);
  299 (* VOLATILE *);
  300 (* VOID *);
  301 (* STRUCT *);
  302 (* UNION *);
  303 (* ENUM *);
  304 (* ELLIPSIS *);
  305 (* CASE *);
  306 (* DEFAULT *);
  307 (* IF *);
  308 (* ELSE *);
  309 (* SWITCH *);
  310 (* WHILE *);
  311 (* DO *);
  312 (* FOR *);
  313 (* GOTO *);
  314 (* CONTINUE *);
  315 (* BREAK *);
  316 (* RETURN *);
  317 (* SEMICOLON *);
  318 (* LBRACE *);
  319 (* RBRACE *);
  320 (* COMMA *);
  321 (* COLON *);
  322 (* EQUAL *);
  323 (* LPAR *);
  324 (* RPAR *);
  325 (* LSQUARE *);
  326 (* RSQUARE *);
  327 (* DOT *);
  328 (* AMP *);
  329 (* EXL *);
  330 (* TILDE *);
  331 (* MINUS *);
  332 (* PLUS *);
  333 (* STAR *);
  334 (* SLASH *);
  335 (* PERCENT *);
  336 (* LT *);
  337 (* GT *);
  338 (* HAT *);
  339 (* PIPE *);
  340 (* QUESTION *);
    0 (* EOF *);
    0|]

let yytransl_block = [|
  257 (* ANNOT *);
  258 (* WDECL *);
  259 (* IDENTIFIER *);
  260 (* CONSTANT *);
  261 (* STRING_LITERAL *);
  262 (* TYPE_NAME *);
    0|]

let yylhs = "\255\255\
\001\000\001\000\003\000\003\000\003\000\003\000\005\000\005\000\
\005\000\005\000\005\000\005\000\005\000\005\000\006\000\006\000\
\008\000\008\000\008\000\008\000\008\000\008\000\009\000\009\000\
\009\000\009\000\009\000\009\000\010\000\010\000\012\000\012\000\
\012\000\012\000\013\000\013\000\013\000\014\000\014\000\014\000\
\015\000\015\000\015\000\015\000\015\000\016\000\016\000\016\000\
\017\000\017\000\018\000\018\000\019\000\019\000\020\000\020\000\
\021\000\021\000\022\000\022\000\007\000\007\000\023\000\023\000\
\023\000\023\000\023\000\023\000\023\000\023\000\023\000\023\000\
\023\000\004\000\004\000\024\000\025\000\025\000\025\000\026\000\
\026\000\026\000\026\000\026\000\026\000\027\000\027\000\031\000\
\031\000\028\000\028\000\028\000\028\000\028\000\029\000\029\000\
\029\000\029\000\029\000\029\000\029\000\029\000\029\000\029\000\
\029\000\029\000\034\000\034\000\034\000\036\000\036\000\037\000\
\037\000\038\000\039\000\039\000\039\000\039\000\040\000\040\000\
\041\000\041\000\041\000\035\000\035\000\035\000\042\000\042\000\
\043\000\043\000\030\000\030\000\032\000\032\000\045\000\045\000\
\045\000\045\000\045\000\045\000\045\000\047\000\047\000\044\000\
\044\000\044\000\044\000\049\000\049\000\046\000\046\000\050\000\
\050\000\051\000\051\000\051\000\048\000\048\000\011\000\011\000\
\052\000\052\000\052\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\053\000\033\000\033\000\033\000\054\000\
\054\000\055\000\055\000\055\000\055\000\055\000\055\000\056\000\
\056\000\056\000\057\000\057\000\057\000\057\000\064\000\063\000\
\063\000\062\000\062\000\058\000\058\000\059\000\059\000\059\000\
\060\000\060\000\060\000\060\000\061\000\061\000\061\000\061\000\
\061\000\002\000\002\000\065\000\065\000\066\000\066\000\066\000\
\066\000\000\000"

let yylen = "\002\000\
\002\000\001\000\001\000\001\000\001\000\003\000\001\000\004\000\
\003\000\004\000\003\000\003\000\002\000\002\000\001\000\003\000\
\001\000\002\000\002\000\002\000\002\000\004\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\004\000\001\000\003\000\
\003\000\003\000\001\000\003\000\003\000\001\000\003\000\003\000\
\001\000\003\000\003\000\003\000\003\000\001\000\003\000\003\000\
\001\000\003\000\001\000\003\000\001\000\003\000\001\000\003\000\
\001\000\003\000\001\000\005\000\001\000\003\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\003\000\001\000\002\000\003\000\001\000\001\000\
\002\000\001\000\002\000\001\000\002\000\001\000\003\000\001\000\
\003\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\005\000\004\000\002\000\001\000\001\000\001\000\
\002\000\003\000\002\000\001\000\002\000\001\000\001\000\003\000\
\001\000\002\000\003\000\004\000\005\000\002\000\001\000\003\000\
\001\000\003\000\001\000\001\000\002\000\001\000\001\000\003\000\
\004\000\003\000\005\000\004\000\004\000\001\000\000\000\001\000\
\002\000\002\000\003\000\001\000\002\000\001\000\003\000\001\000\
\003\000\002\000\002\000\001\000\001\000\003\000\001\000\002\000\
\001\000\001\000\002\000\003\000\002\000\003\000\003\000\004\000\
\002\000\003\000\003\000\004\000\001\000\003\000\004\000\001\000\
\003\000\001\000\001\000\001\000\001\000\001\000\001\000\003\000\
\004\000\003\000\002\000\003\000\003\000\004\000\002\000\001\000\
\002\000\001\000\002\000\001\000\002\000\005\000\007\000\005\000\
\006\000\008\000\007\000\008\000\003\000\002\000\002\000\002\000\
\003\000\001\000\002\000\001\000\001\000\004\000\003\000\003\000\
\002\000\002\000"

let yydefred = "\000\000\
\000\000\000\000\079\000\135\000\106\000\090\000\091\000\092\000\
\093\000\094\000\096\000\097\000\098\000\099\000\102\000\103\000\
\100\000\101\000\131\000\132\000\095\000\110\000\111\000\000\000\
\000\000\000\000\002\000\218\000\000\000\213\000\000\000\000\000\
\000\000\000\000\000\000\104\000\105\000\000\000\000\000\000\000\
\210\000\212\000\000\000\000\000\000\000\148\000\146\000\000\000\
\001\000\211\000\077\000\000\000\086\000\000\000\081\000\083\000\
\085\000\000\000\192\000\000\000\217\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\127\000\136\000\
\149\000\147\000\078\000\000\000\000\000\000\000\000\000\215\000\
\000\000\004\000\005\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\196\000\187\000\000\000\023\000\028\000\027\000\026\000\
\025\000\024\000\007\000\000\000\000\000\074\000\000\000\000\000\
\031\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\061\000\194\000\178\000\179\000\180\000\
\181\000\182\000\183\000\000\000\000\000\000\000\193\000\216\000\
\000\000\000\000\000\000\000\000\112\000\000\000\157\000\000\000\
\000\000\000\000\000\000\000\000\152\000\003\000\138\000\029\000\
\076\000\000\000\000\000\000\000\124\000\000\000\087\000\000\000\
\173\000\089\000\142\000\191\000\214\000\000\000\000\000\021\000\
\000\000\018\000\019\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\206\000\207\000\208\000\000\000\000\000\
\000\000\000\000\197\000\000\000\000\000\013\000\014\000\000\000\
\000\000\000\000\064\000\065\000\066\000\067\000\068\000\069\000\
\070\000\071\000\072\000\073\000\063\000\000\000\020\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\188\000\195\000\189\000\000\000\000\000\115\000\
\117\000\108\000\113\000\000\000\000\000\000\000\119\000\141\000\
\000\000\000\000\154\000\000\000\155\000\000\000\000\000\000\000\
\140\000\000\000\137\000\125\000\130\000\128\000\176\000\000\000\
\184\000\000\000\000\000\186\000\000\000\000\000\000\000\000\000\
\000\000\205\000\209\000\006\000\000\000\000\000\000\000\160\000\
\075\000\012\000\009\000\000\000\015\000\000\000\011\000\062\000\
\032\000\033\000\034\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\190\000\107\000\122\000\000\000\114\000\
\000\000\169\000\000\000\000\000\165\000\000\000\000\000\000\000\
\000\000\139\000\158\000\151\000\153\000\174\000\000\000\022\000\
\185\000\000\000\000\000\000\000\000\000\000\000\030\000\000\000\
\010\000\008\000\000\000\123\000\120\000\170\000\164\000\166\000\
\171\000\000\000\167\000\000\000\175\000\177\000\000\000\200\000\
\000\000\000\000\000\000\000\000\016\000\060\000\172\000\168\000\
\000\000\201\000\000\000\000\000\000\000\199\000\000\000\203\000\
\000\000\202\000\204\000"

let yydgoto = "\002\000\
\028\000\029\000\107\000\108\000\109\000\020\001\110\000\111\000\
\112\000\113\000\185\000\114\000\115\000\116\000\117\000\118\000\
\119\000\120\000\121\000\122\000\123\000\124\000\206\000\154\000\
\059\000\060\000\052\000\032\000\033\000\034\000\053\000\035\000\
\162\000\036\000\037\000\038\000\140\000\141\000\142\000\238\000\
\239\000\070\000\071\000\039\000\040\000\051\001\164\000\147\000\
\048\000\148\000\149\000\052\001\246\000\000\001\125\000\126\000\
\127\000\128\000\129\000\130\000\131\000\132\000\062\000\080\000\
\041\000\042\000"

let yysindex = "\018\000\
\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\026\255\
\046\255\098\255\000\000\000\000\020\000\000\000\015\000\168\007\
\168\007\168\007\064\007\000\000\000\000\050\255\015\255\250\254\
\000\000\000\000\220\254\031\255\229\254\000\000\000\000\098\255\
\000\000\000\000\000\000\231\254\000\000\002\007\000\000\000\000\
\000\000\029\001\000\000\015\000\000\000\064\007\248\254\121\007\
\250\254\238\006\061\255\031\255\099\255\058\255\000\000\000\000\
\000\000\000\000\000\000\046\255\181\002\198\255\064\007\000\000\
\108\255\000\000\000\000\000\003\013\003\013\003\041\003\147\255\
\195\255\200\255\216\255\105\002\218\255\217\255\140\255\188\255\
\210\002\000\000\000\000\180\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\129\255\186\000\000\000\099\000\041\003\
\000\000\126\000\254\254\118\255\024\255\176\255\253\255\248\255\
\250\255\067\000\027\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\044\002\105\001\030\000\000\000\000\000\
\121\007\121\007\121\007\192\003\000\000\010\255\000\000\198\255\
\039\255\063\000\008\255\078\000\000\000\000\000\000\000\000\000\
\000\000\070\000\212\255\041\003\000\000\031\255\000\000\181\002\
\000\000\000\000\000\000\000\000\000\000\105\002\180\001\000\000\
\041\003\000\000\000\000\082\000\105\002\041\003\041\003\041\003\
\190\000\242\002\150\000\000\000\000\000\000\000\164\255\120\255\
\086\000\246\254\000\000\041\003\212\000\000\000\000\000\125\000\
\041\003\224\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\041\003\000\000\041\003\
\041\003\041\003\041\003\041\003\041\003\041\003\041\003\041\003\
\041\003\041\003\041\003\041\003\041\003\041\003\041\003\041\003\
\041\003\041\003\000\000\000\000\000\000\074\002\106\007\000\000\
\000\000\000\000\000\000\041\003\165\000\175\255\000\000\000\000\
\165\002\046\001\000\000\076\255\000\000\014\255\198\255\229\000\
\000\000\148\007\000\000\000\000\000\000\000\000\000\000\081\000\
\000\000\167\000\105\002\000\000\134\255\151\255\153\255\197\000\
\242\002\000\000\000\000\000\000\041\003\226\004\203\255\000\000\
\000\000\000\000\000\000\158\255\000\000\117\255\000\000\000\000\
\000\000\000\000\000\000\126\000\126\000\254\254\254\254\118\255\
\118\255\118\255\118\255\024\255\024\255\176\255\253\255\248\255\
\250\255\067\000\103\000\000\000\000\000\000\000\041\003\000\000\
\010\255\000\000\184\000\188\000\000\000\191\000\014\255\045\007\
\121\001\000\000\000\000\000\000\000\000\000\000\076\000\000\000\
\000\000\105\002\105\002\253\000\206\000\221\002\000\000\041\003\
\000\000\000\000\041\003\000\000\000\000\000\000\000\000\000\000\
\000\000\207\000\000\000\204\000\000\000\000\000\225\000\000\000\
\105\002\041\003\021\001\169\255\000\000\000\000\000\000\000\000\
\105\002\000\000\174\255\105\002\022\001\000\000\219\000\000\000\
\105\002\000\000\000\000"

let yyrindex = "\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\091\000\000\000\000\000\000\000\000\000\000\000\136\255\
\163\255\032\003\000\000\000\000\000\000\000\000\000\000\147\006\
\000\000\000\000\199\001\000\000\000\000\000\000\000\000\153\000\
\000\000\000\000\000\000\000\000\000\000\183\255\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\255\001\000\000\
\193\006\000\000\000\000\000\000\100\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\069\000\000\000\000\000\
\162\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\108\003\000\000\132\003\000\000\
\000\000\206\003\072\004\005\005\153\005\010\004\042\006\074\006\
\093\003\035\004\143\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\183\255\000\000\000\000\
\000\000\030\255\141\255\000\000\000\000\000\000\000\000\011\006\
\213\255\000\000\000\000\228\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\230\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\197\255\000\000\000\000\000\000\
\000\000\000\000\000\000\073\000\000\000\093\000\011\006\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\231\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\230\003\048\004\146\004\170\004\035\005\
\065\005\095\005\125\005\183\005\211\005\108\004\050\006\082\006\
\188\003\133\004\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\098\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\209\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\000\000\003\000\000\000\000\000\182\255\194\255\
\000\000\172\255\126\001\013\001\034\001\129\000\030\001\076\001\
\079\001\080\001\078\001\083\001\000\000\196\255\000\000\209\255\
\031\000\014\000\000\000\000\000\208\255\069\001\228\001\231\255\
\106\255\000\000\000\000\000\000\173\001\127\255\173\255\000\000\
\008\001\009\002\179\001\238\255\226\255\192\255\124\255\000\000\
\000\000\000\000\099\001\132\255\043\255\000\000\168\255\000\000\
\132\000\092\255\000\000\000\000\000\000\217\001\192\000\000\000\
\066\002\000\000"

let yytablesize = 2263
let yytable = "\045\000\
\027\000\146\000\161\000\177\000\152\000\054\000\153\000\047\000\
\065\000\255\000\235\000\240\000\004\000\009\001\031\000\138\000\
\186\000\004\000\001\000\049\000\245\000\168\000\170\000\171\000\
\152\000\068\000\153\000\207\000\043\000\074\000\055\001\030\000\
\116\000\069\000\134\000\075\000\215\000\216\000\076\000\172\000\
\072\000\004\000\031\000\228\000\225\000\055\000\056\000\057\000\
\004\000\152\000\134\000\138\000\063\000\137\000\232\000\233\000\
\014\001\055\001\242\000\030\000\066\000\016\001\067\000\150\000\
\082\000\083\000\026\000\084\000\143\000\085\000\086\000\248\000\
\211\000\212\000\236\000\249\000\025\000\001\001\004\000\145\000\
\056\001\025\000\057\001\186\000\004\001\161\000\026\000\044\000\
\138\000\138\000\138\000\138\000\135\000\152\000\116\000\153\000\
\116\000\116\000\116\000\183\000\070\001\235\000\184\000\217\000\
\218\000\241\000\116\000\242\000\253\000\135\000\226\000\064\000\
\025\000\017\001\058\001\026\000\237\000\021\001\138\000\243\000\
\157\000\158\000\026\000\025\001\026\001\027\001\244\000\100\000\
\213\000\214\000\151\000\024\001\101\000\102\000\103\000\104\000\
\105\000\106\000\080\000\019\000\020\000\228\000\241\000\118\000\
\242\000\152\000\152\000\152\000\152\000\152\000\152\000\152\000\
\152\000\152\000\152\000\152\000\152\000\152\000\152\000\152\000\
\152\000\152\000\152\000\135\000\156\000\082\000\061\000\015\001\
\086\001\184\000\065\001\184\000\166\000\152\000\026\000\153\000\
\005\001\006\001\007\001\152\000\188\000\153\000\138\000\188\000\
\071\001\078\000\074\001\012\001\046\001\187\000\219\000\220\000\
\188\000\136\000\054\001\022\001\080\000\188\000\163\000\080\000\
\180\000\066\001\080\000\080\000\080\000\118\000\152\000\118\000\
\118\000\118\000\165\000\173\000\080\000\065\000\188\000\045\000\
\188\000\118\000\067\001\179\000\068\001\072\001\244\000\082\000\
\011\001\073\001\082\000\188\000\043\001\082\000\082\000\082\000\
\188\000\087\001\088\001\048\001\101\001\188\000\049\001\082\000\
\152\000\103\001\153\000\088\000\161\000\079\000\088\000\082\001\
\181\000\133\000\152\000\015\001\153\000\093\001\145\000\076\001\
\098\001\121\000\003\000\004\000\121\000\174\000\005\000\145\000\
\102\001\084\001\175\000\104\001\152\000\014\001\094\001\242\000\
\107\001\004\000\252\000\158\000\156\000\003\000\004\000\237\000\
\156\000\005\000\176\000\145\000\178\000\006\000\007\000\008\000\
\009\000\010\000\011\000\012\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\006\000\007\000\008\000\009\000\010\000\011\000\012\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\221\000\145\000\143\000\143\000\
\092\001\222\000\143\000\051\000\223\000\026\000\150\000\082\000\
\083\000\025\000\084\000\224\000\085\000\086\000\025\000\032\001\
\033\001\034\001\035\001\026\000\099\001\144\000\046\000\077\000\
\026\000\143\000\143\000\143\000\143\000\143\000\143\000\143\000\
\143\000\143\000\143\000\143\000\143\000\143\000\143\000\143\000\
\143\000\143\000\143\000\143\000\073\000\195\000\196\000\197\000\
\198\000\199\000\200\000\201\000\202\000\203\000\204\000\150\000\
\082\000\083\000\247\000\084\000\139\000\085\000\086\000\143\000\
\161\000\160\000\085\001\251\000\161\000\250\000\100\000\062\001\
\063\001\143\000\003\001\101\000\102\000\103\000\104\000\105\000\
\106\000\013\001\144\000\145\000\162\000\144\000\144\000\144\000\
\162\000\163\000\129\000\129\000\205\000\163\000\188\000\075\001\
\139\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\008\001\100\000\
\019\001\189\000\190\000\191\000\101\000\102\000\103\000\104\000\
\105\000\106\000\208\000\209\000\210\000\139\000\139\000\139\000\
\139\000\198\000\010\001\198\000\198\000\198\000\018\001\198\000\
\145\000\198\000\198\000\145\000\145\000\145\000\003\000\028\001\
\029\001\003\000\023\001\003\000\003\000\047\001\003\000\059\001\
\003\000\003\000\064\001\139\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\030\001\031\001\
\036\001\037\001\069\001\078\001\192\000\089\001\193\000\079\001\
\194\000\198\000\198\000\198\000\080\001\198\000\198\000\198\000\
\198\000\198\000\198\000\198\000\198\000\198\000\198\000\198\000\
\090\001\096\001\095\001\198\000\097\001\100\001\105\001\106\001\
\198\000\198\000\198\000\198\000\198\000\198\000\003\000\081\000\
\082\000\083\000\005\000\084\000\002\001\085\000\086\000\150\000\
\038\001\159\000\161\000\139\000\039\001\041\001\040\001\159\000\
\150\000\082\000\083\000\042\001\084\000\231\000\085\000\086\000\
\077\001\006\000\007\000\008\000\009\000\010\000\011\000\012\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\155\000\087\000\088\000\089\000\
\254\000\090\000\091\000\092\000\093\000\094\000\095\000\096\000\
\097\000\098\000\058\000\099\000\061\001\230\000\050\000\100\000\
\000\000\000\000\000\000\000\000\101\000\102\000\103\000\104\000\
\105\000\106\000\003\000\081\000\082\000\083\000\005\000\084\000\
\100\000\085\000\086\000\053\001\000\000\101\000\102\000\103\000\
\104\000\105\000\106\000\150\000\082\000\083\000\000\000\084\000\
\000\000\085\000\086\000\000\000\000\000\006\000\007\000\008\000\
\009\000\010\000\011\000\012\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\000\000\087\000\088\000\089\000\000\000\090\000\091\000\092\000\
\093\000\094\000\095\000\096\000\097\000\098\000\058\000\229\000\
\000\000\000\000\000\000\100\000\000\000\000\000\000\000\000\000\
\101\000\102\000\103\000\104\000\105\000\106\000\150\000\082\000\
\083\000\005\000\084\000\100\000\085\000\086\000\083\001\000\000\
\101\000\102\000\103\000\104\000\105\000\106\000\000\000\000\000\
\000\000\126\000\000\000\059\000\126\000\059\000\059\000\059\000\
\000\000\000\000\059\000\000\000\059\000\011\000\012\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\126\000\126\000\126\000\126\000\126\000\
\126\000\126\000\126\000\126\000\126\000\126\000\126\000\126\000\
\126\000\126\000\126\000\126\000\126\000\126\000\100\000\000\000\
\000\000\000\000\000\000\101\000\102\000\103\000\104\000\105\000\
\106\000\109\000\000\000\126\000\109\000\000\000\126\000\126\000\
\000\000\126\000\126\000\126\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\126\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\109\000\109\000\109\000\109\000\109\000\
\109\000\109\000\109\000\109\000\109\000\109\000\109\000\109\000\
\109\000\109\000\109\000\109\000\109\000\109\000\081\000\082\000\
\083\000\000\000\084\000\000\000\085\000\086\000\000\000\000\000\
\000\000\000\000\000\000\109\000\000\000\000\000\109\000\109\000\
\000\000\109\000\109\000\109\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\109\000\081\000\082\000\083\000\000\000\
\084\000\000\000\085\000\086\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\087\000\088\000\089\000\000\000\
\090\000\091\000\092\000\093\000\094\000\095\000\096\000\097\000\
\098\000\058\000\227\000\081\000\082\000\083\000\100\000\084\000\
\000\000\085\000\086\000\101\000\102\000\103\000\104\000\105\000\
\106\000\000\000\087\000\088\000\089\000\000\000\090\000\091\000\
\092\000\093\000\094\000\095\000\096\000\097\000\098\000\058\000\
\044\001\000\000\000\000\000\000\100\000\000\000\000\000\000\000\
\000\000\101\000\102\000\103\000\104\000\105\000\106\000\000\000\
\000\000\087\000\088\000\089\000\000\000\090\000\091\000\092\000\
\093\000\094\000\095\000\096\000\097\000\098\000\058\000\004\000\
\000\000\000\000\005\000\100\000\000\000\000\000\000\000\000\000\
\101\000\102\000\103\000\104\000\105\000\106\000\000\000\150\000\
\082\000\083\000\000\000\084\000\000\000\085\000\086\000\000\000\
\000\000\006\000\007\000\008\000\009\000\010\000\011\000\012\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\150\000\082\000\083\000\000\000\
\084\000\000\000\085\000\086\000\000\000\000\000\000\000\150\000\
\082\000\083\000\000\000\084\000\000\000\085\000\086\000\241\000\
\050\001\242\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\026\000\160\000\000\000\150\000\082\000\083\000\100\000\
\084\000\000\000\085\000\086\000\101\000\102\000\103\000\104\000\
\105\000\106\000\150\000\082\000\083\000\000\000\084\000\000\000\
\085\000\086\000\000\000\000\000\000\000\000\000\182\000\150\000\
\082\000\083\000\000\000\084\000\100\000\085\000\086\000\000\000\
\000\000\101\000\102\000\103\000\104\000\105\000\106\000\100\000\
\091\001\000\000\084\000\000\000\101\000\102\000\103\000\104\000\
\105\000\106\000\000\000\150\000\082\000\083\000\098\000\084\000\
\000\000\085\000\086\000\000\000\100\000\000\000\000\000\000\000\
\000\000\101\000\102\000\103\000\104\000\105\000\106\000\000\000\
\000\000\000\000\167\000\000\000\000\000\000\000\000\000\101\000\
\102\000\103\000\104\000\105\000\106\000\000\000\000\000\169\000\
\000\000\000\000\000\000\000\000\101\000\102\000\103\000\104\000\
\105\000\106\000\000\000\000\000\084\000\000\000\000\000\084\000\
\000\000\000\000\084\000\084\000\084\000\000\000\000\000\000\000\
\000\000\000\000\000\000\100\000\084\000\055\000\055\000\000\000\
\101\000\102\000\103\000\104\000\105\000\106\000\017\000\017\000\
\017\000\017\000\017\000\017\000\017\000\017\000\017\000\017\000\
\017\000\017\000\017\000\017\000\017\000\017\000\017\000\017\000\
\000\000\000\000\000\000\000\000\000\000\000\000\029\000\029\000\
\029\000\029\000\029\000\029\000\029\000\029\000\000\000\000\000\
\000\000\055\000\000\000\055\000\055\000\055\000\000\000\000\000\
\055\000\000\000\055\000\000\000\000\000\000\000\000\000\000\000\
\017\000\000\000\017\000\017\000\017\000\017\000\000\000\017\000\
\055\000\017\000\000\000\017\000\000\000\000\000\017\000\017\000\
\017\000\017\000\017\000\017\000\017\000\017\000\017\000\017\000\
\029\000\000\000\029\000\029\000\029\000\005\000\000\000\029\000\
\000\000\029\000\000\000\029\000\056\000\056\000\029\000\029\000\
\029\000\029\000\029\000\029\000\029\000\029\000\029\000\029\000\
\035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
\000\000\011\000\012\000\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\024\000\000\000\
\037\000\037\000\037\000\037\000\037\000\037\000\037\000\037\000\
\056\000\000\000\056\000\056\000\056\000\000\000\234\000\056\000\
\000\000\056\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\035\000\000\000\035\000\035\000\035\000\056\000\
\000\000\035\000\000\000\035\000\000\000\035\000\000\000\000\000\
\035\000\035\000\049\000\049\000\000\000\035\000\035\000\035\000\
\035\000\035\000\037\000\000\000\037\000\037\000\037\000\000\000\
\000\000\037\000\000\000\037\000\000\000\037\000\000\000\000\000\
\037\000\037\000\000\000\000\000\057\000\037\000\037\000\037\000\
\037\000\037\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\036\000\000\000\000\000\000\000\000\000\049\000\000\000\
\049\000\049\000\049\000\000\000\000\000\049\000\000\000\049\000\
\000\000\049\000\038\000\038\000\038\000\038\000\038\000\038\000\
\038\000\038\000\000\000\049\000\049\000\049\000\000\000\057\000\
\000\000\057\000\057\000\057\000\000\000\000\000\057\000\000\000\
\057\000\000\000\000\000\000\000\036\000\000\000\036\000\036\000\
\036\000\000\000\000\000\036\000\000\000\036\000\057\000\036\000\
\000\000\000\000\036\000\036\000\050\000\050\000\000\000\036\000\
\036\000\036\000\036\000\036\000\038\000\000\000\038\000\038\000\
\038\000\000\000\000\000\038\000\000\000\038\000\000\000\038\000\
\000\000\000\000\000\000\000\000\000\000\000\000\058\000\038\000\
\038\000\038\000\038\000\038\000\039\000\039\000\039\000\039\000\
\039\000\039\000\039\000\039\000\000\000\000\000\000\000\000\000\
\050\000\000\000\050\000\050\000\050\000\000\000\000\000\050\000\
\000\000\050\000\000\000\050\000\040\000\040\000\040\000\040\000\
\040\000\040\000\040\000\040\000\000\000\050\000\050\000\050\000\
\000\000\058\000\000\000\058\000\058\000\058\000\000\000\000\000\
\058\000\000\000\058\000\000\000\000\000\000\000\039\000\000\000\
\039\000\039\000\039\000\000\000\000\000\039\000\000\000\039\000\
\058\000\039\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\039\000\039\000\039\000\039\000\039\000\040\000\005\000\
\040\000\040\000\040\000\000\000\000\000\040\000\000\000\040\000\
\000\000\040\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\040\000\040\000\040\000\040\000\040\000\006\000\007\000\
\008\000\009\000\010\000\011\000\012\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\041\000\041\000\041\000\041\000\041\000\041\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\014\001\050\001\242\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\026\000\044\000\
\044\000\044\000\044\000\044\000\044\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\041\000\000\000\041\000\041\000\041\000\000\000\000\000\
\041\000\000\000\041\000\000\000\041\000\045\000\045\000\045\000\
\045\000\045\000\045\000\000\000\041\000\041\000\041\000\041\000\
\041\000\000\000\000\000\000\000\000\000\000\000\000\000\044\000\
\000\000\044\000\044\000\044\000\000\000\000\000\044\000\000\000\
\044\000\000\000\044\000\042\000\042\000\042\000\042\000\042\000\
\042\000\000\000\044\000\044\000\044\000\044\000\044\000\000\000\
\000\000\000\000\000\000\000\000\000\000\045\000\000\000\045\000\
\045\000\045\000\000\000\000\000\045\000\000\000\045\000\000\000\
\045\000\043\000\043\000\043\000\043\000\043\000\043\000\000\000\
\045\000\045\000\045\000\045\000\045\000\000\000\000\000\000\000\
\000\000\000\000\000\000\042\000\000\000\042\000\042\000\042\000\
\000\000\000\000\042\000\000\000\042\000\000\000\042\000\046\000\
\046\000\046\000\046\000\000\000\000\000\000\000\042\000\042\000\
\042\000\042\000\042\000\000\000\000\000\000\000\000\000\000\000\
\000\000\043\000\000\000\043\000\043\000\043\000\000\000\000\000\
\043\000\000\000\043\000\000\000\043\000\047\000\047\000\047\000\
\047\000\000\000\000\000\000\000\043\000\043\000\043\000\043\000\
\043\000\000\000\000\000\000\000\000\000\046\000\000\000\046\000\
\046\000\046\000\000\000\000\000\046\000\000\000\046\000\000\000\
\046\000\048\000\048\000\048\000\048\000\000\000\000\000\000\000\
\000\000\000\000\046\000\046\000\046\000\000\000\000\000\000\000\
\000\000\000\000\000\000\047\000\000\000\047\000\047\000\047\000\
\000\000\000\000\047\000\000\000\047\000\000\000\047\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\047\000\047\000\047\000\000\000\143\000\000\000\000\000\048\000\
\143\000\048\000\048\000\048\000\000\000\000\000\048\000\000\000\
\048\000\000\000\048\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\048\000\048\000\048\000\143\000\
\143\000\143\000\143\000\143\000\143\000\143\000\143\000\143\000\
\143\000\143\000\143\000\143\000\143\000\143\000\143\000\143\000\
\143\000\143\000\051\000\051\000\000\000\000\000\000\000\000\000\
\000\000\000\000\052\000\052\000\000\000\000\000\000\000\143\000\
\143\000\000\000\143\000\143\000\143\000\143\000\143\000\143\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\053\000\053\000\000\000\000\000\000\000\000\000\
\000\000\000\000\054\000\054\000\000\000\000\000\051\000\000\000\
\051\000\051\000\051\000\000\000\000\000\051\000\052\000\051\000\
\052\000\052\000\052\000\000\000\000\000\052\000\000\000\052\000\
\000\000\000\000\000\000\051\000\051\000\051\000\000\000\000\000\
\000\000\000\000\000\000\052\000\052\000\052\000\053\000\000\000\
\053\000\053\000\053\000\000\000\000\000\053\000\054\000\053\000\
\054\000\054\000\054\000\000\000\134\000\054\000\000\000\054\000\
\134\000\000\000\000\000\000\000\053\000\053\000\000\000\000\000\
\000\000\000\000\000\000\000\000\054\000\054\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\134\000\
\134\000\134\000\134\000\134\000\134\000\134\000\134\000\134\000\
\134\000\134\000\134\000\134\000\134\000\134\000\134\000\134\000\
\134\000\134\000\133\000\000\000\000\000\000\000\133\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\134\000\
\134\000\000\000\134\000\134\000\134\000\000\000\134\000\000\000\
\000\000\000\000\000\000\000\000\000\000\133\000\133\000\133\000\
\133\000\133\000\133\000\133\000\133\000\133\000\133\000\133\000\
\133\000\133\000\133\000\133\000\133\000\133\000\133\000\133\000\
\143\000\000\000\000\000\005\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\133\000\133\000\000\000\
\133\000\133\000\133\000\003\000\133\000\000\000\000\000\005\000\
\000\000\000\000\006\000\007\000\008\000\009\000\010\000\011\000\
\012\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\000\000\006\000\007\000\
\008\000\009\000\010\000\011\000\012\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\144\000\005\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\058\000\
\000\000\003\000\000\000\077\000\000\000\005\000\000\000\000\000\
\000\000\006\000\007\000\008\000\009\000\010\000\011\000\012\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\006\000\007\000\008\000\009\000\
\010\000\011\000\012\000\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\024\000\005\000\
\081\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\058\000\005\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\011\000\012\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\005\000\011\000\012\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\045\001\000\000\000\000\000\000\000\000\005\000\000\000\000\000\
\006\000\007\000\008\000\009\000\010\000\011\000\012\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\060\001\006\000\007\000\008\000\009\000\
\010\000\011\000\012\000\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\024\000"

let yycheck = "\025\000\
\000\000\066\000\077\000\092\000\067\000\031\000\067\000\026\000\
\039\000\160\000\140\000\144\000\003\001\178\000\001\000\064\000\
\100\000\003\001\001\000\000\000\145\000\084\000\085\000\086\000\
\087\000\062\001\087\000\112\000\003\001\048\000\244\000\001\000\
\003\001\003\001\060\000\061\001\013\001\014\001\064\001\087\000\
\068\001\003\001\029\000\132\000\018\001\032\000\033\000\034\000\
\003\001\112\000\076\000\100\000\003\001\062\001\138\000\139\000\
\067\001\015\001\069\001\029\000\067\001\186\000\069\001\003\001\
\004\001\005\001\077\001\007\001\000\000\009\001\010\001\064\001\
\075\001\076\001\065\001\068\001\067\001\166\000\003\001\066\000\
\067\001\067\001\069\001\167\000\173\000\160\000\077\001\062\001\
\137\000\138\000\139\000\140\000\062\000\156\000\065\001\156\000\
\067\001\068\001\069\001\097\000\009\001\231\000\100\000\080\001\
\081\001\067\001\077\001\069\001\156\000\079\000\084\001\062\001\
\067\001\188\000\247\000\077\001\142\000\192\000\167\000\145\000\
\063\001\064\001\077\001\208\000\209\000\210\000\145\000\067\001\
\011\001\012\001\070\001\206\000\072\001\073\001\074\001\075\001\
\076\001\077\001\003\001\042\001\043\001\230\000\067\001\003\001\
\069\001\208\000\209\000\210\000\211\000\212\000\213\000\214\000\
\215\000\216\000\217\000\218\000\219\000\220\000\221\000\222\000\
\223\000\224\000\225\000\133\000\066\001\003\001\035\000\186\000\
\063\001\167\000\003\001\169\000\065\001\236\000\077\001\236\000\
\174\000\175\000\176\000\242\000\064\001\242\000\231\000\064\001\
\013\001\054\000\070\001\068\001\236\000\061\001\015\001\016\001\
\064\001\062\000\242\000\193\000\061\001\064\001\001\001\064\001\
\061\001\068\001\067\001\068\001\069\001\065\001\013\001\067\001\
\068\001\069\001\079\000\065\001\077\001\244\000\064\001\241\000\
\064\001\077\001\068\001\003\001\068\001\064\001\241\000\061\001\
\061\001\068\001\064\001\064\001\226\000\067\001\068\001\069\001\
\064\001\066\001\067\001\061\001\068\001\064\001\064\001\077\001\
\047\001\068\001\047\001\061\001\063\001\054\000\064\001\056\001\
\061\001\058\000\057\001\014\001\057\001\072\001\241\000\047\001\
\089\001\061\001\002\001\003\001\064\001\067\001\006\001\250\000\
\097\001\057\001\067\001\100\001\075\001\067\001\075\001\069\001\
\105\001\003\001\063\001\064\001\064\001\002\001\003\001\049\001\
\068\001\006\001\067\001\014\001\067\001\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\029\001\030\001\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\067\001\072\001\056\001\002\001\003\001\
\070\001\082\001\006\001\061\001\083\001\077\001\003\001\004\001\
\005\001\067\001\007\001\017\001\009\001\010\001\067\001\215\000\
\216\000\217\000\218\000\077\001\090\001\003\001\026\000\066\001\
\077\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\000\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\003\001\
\004\001\005\001\068\001\007\001\064\000\009\001\010\001\067\001\
\064\001\062\001\063\001\070\001\068\001\064\001\067\001\063\001\
\064\001\077\001\065\001\072\001\073\001\074\001\075\001\076\001\
\077\001\068\001\064\001\003\001\064\001\067\001\068\001\069\001\
\068\001\064\001\063\001\064\001\066\001\068\001\064\001\065\001\
\100\000\008\001\009\001\010\001\011\001\012\001\013\001\014\001\
\015\001\016\001\017\001\018\001\019\001\020\001\021\001\022\001\
\023\001\024\001\025\001\026\001\027\001\028\001\001\001\067\001\
\068\001\008\001\009\001\010\001\072\001\073\001\074\001\075\001\
\076\001\077\001\077\001\078\001\079\001\137\000\138\000\139\000\
\140\000\001\001\061\001\003\001\004\001\005\001\003\001\007\001\
\064\001\009\001\010\001\067\001\068\001\069\001\061\001\211\000\
\212\000\064\001\003\001\066\001\067\001\065\001\069\001\003\001\
\071\001\072\001\068\001\167\000\075\001\076\001\077\001\078\001\
\079\001\080\001\081\001\082\001\083\001\084\001\213\000\214\000\
\219\000\220\000\054\001\068\001\067\001\001\001\069\001\068\001\
\071\001\049\001\050\001\051\001\070\001\053\001\054\001\055\001\
\056\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\067\001\070\001\068\001\067\001\052\001\001\001\001\001\061\001\
\072\001\073\001\074\001\075\001\076\001\077\001\002\001\003\001\
\004\001\005\001\006\001\007\001\167\000\009\001\010\001\068\001\
\221\000\068\001\068\001\231\000\222\000\224\000\223\000\076\000\
\003\001\004\001\005\001\225\000\007\001\137\000\009\001\010\001\
\049\001\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\068\000\049\001\050\001\051\001\
\158\000\053\001\054\001\055\001\056\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\250\000\133\000\029\000\067\001\
\255\255\255\255\255\255\255\255\072\001\073\001\074\001\075\001\
\076\001\077\001\002\001\003\001\004\001\005\001\006\001\007\001\
\067\001\009\001\010\001\070\001\255\255\072\001\073\001\074\001\
\075\001\076\001\077\001\003\001\004\001\005\001\255\255\007\001\
\255\255\009\001\010\001\255\255\255\255\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\255\255\049\001\050\001\051\001\255\255\053\001\054\001\055\001\
\056\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\255\255\255\255\255\255\067\001\255\255\255\255\255\255\255\255\
\072\001\073\001\074\001\075\001\076\001\077\001\003\001\004\001\
\005\001\006\001\007\001\067\001\009\001\010\001\070\001\255\255\
\072\001\073\001\074\001\075\001\076\001\077\001\255\255\255\255\
\255\255\003\001\255\255\061\001\006\001\063\001\064\001\065\001\
\255\255\255\255\068\001\255\255\070\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\029\001\030\001\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\067\001\255\255\
\255\255\255\255\255\255\072\001\073\001\074\001\075\001\076\001\
\077\001\003\001\255\255\061\001\006\001\255\255\064\001\065\001\
\255\255\067\001\068\001\069\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\077\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\029\001\030\001\031\001\032\001\033\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\003\001\004\001\
\005\001\255\255\007\001\255\255\009\001\010\001\255\255\255\255\
\255\255\255\255\255\255\061\001\255\255\255\255\064\001\065\001\
\255\255\067\001\068\001\069\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\077\001\003\001\004\001\005\001\255\255\
\007\001\255\255\009\001\010\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\049\001\050\001\051\001\255\255\
\053\001\054\001\055\001\056\001\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\003\001\004\001\005\001\067\001\007\001\
\255\255\009\001\010\001\072\001\073\001\074\001\075\001\076\001\
\077\001\255\255\049\001\050\001\051\001\255\255\053\001\054\001\
\055\001\056\001\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\255\255\255\255\255\255\067\001\255\255\255\255\255\255\
\255\255\072\001\073\001\074\001\075\001\076\001\077\001\255\255\
\255\255\049\001\050\001\051\001\255\255\053\001\054\001\055\001\
\056\001\057\001\058\001\059\001\060\001\061\001\062\001\003\001\
\255\255\255\255\006\001\067\001\255\255\255\255\255\255\255\255\
\072\001\073\001\074\001\075\001\076\001\077\001\255\255\003\001\
\004\001\005\001\255\255\007\001\255\255\009\001\010\001\255\255\
\255\255\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\003\001\004\001\005\001\255\255\
\007\001\255\255\009\001\010\001\255\255\255\255\255\255\003\001\
\004\001\005\001\255\255\007\001\255\255\009\001\010\001\067\001\
\068\001\069\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\077\001\062\001\255\255\003\001\004\001\005\001\067\001\
\007\001\255\255\009\001\010\001\072\001\073\001\074\001\075\001\
\076\001\077\001\003\001\004\001\005\001\255\255\007\001\255\255\
\009\001\010\001\255\255\255\255\255\255\255\255\061\001\003\001\
\004\001\005\001\255\255\007\001\067\001\009\001\010\001\255\255\
\255\255\072\001\073\001\074\001\075\001\076\001\077\001\067\001\
\068\001\255\255\003\001\255\255\072\001\073\001\074\001\075\001\
\076\001\077\001\255\255\003\001\004\001\005\001\061\001\007\001\
\255\255\009\001\010\001\255\255\067\001\255\255\255\255\255\255\
\255\255\072\001\073\001\074\001\075\001\076\001\077\001\255\255\
\255\255\255\255\067\001\255\255\255\255\255\255\255\255\072\001\
\073\001\074\001\075\001\076\001\077\001\255\255\255\255\067\001\
\255\255\255\255\255\255\255\255\072\001\073\001\074\001\075\001\
\076\001\077\001\255\255\255\255\061\001\255\255\255\255\064\001\
\255\255\255\255\067\001\068\001\069\001\255\255\255\255\255\255\
\255\255\255\255\255\255\067\001\077\001\017\001\018\001\255\255\
\072\001\073\001\074\001\075\001\076\001\077\001\011\001\012\001\
\013\001\014\001\015\001\016\001\017\001\018\001\019\001\020\001\
\021\001\022\001\023\001\024\001\025\001\026\001\027\001\028\001\
\255\255\255\255\255\255\255\255\255\255\255\255\011\001\012\001\
\013\001\014\001\015\001\016\001\017\001\018\001\255\255\255\255\
\255\255\061\001\255\255\063\001\064\001\065\001\255\255\255\255\
\068\001\255\255\070\001\255\255\255\255\255\255\255\255\255\255\
\061\001\255\255\063\001\064\001\065\001\066\001\255\255\068\001\
\084\001\070\001\255\255\072\001\255\255\255\255\075\001\076\001\
\077\001\078\001\079\001\080\001\081\001\082\001\083\001\084\001\
\061\001\255\255\063\001\064\001\065\001\006\001\255\255\068\001\
\255\255\070\001\255\255\072\001\017\001\018\001\075\001\076\001\
\077\001\078\001\079\001\080\001\081\001\082\001\083\001\084\001\
\011\001\012\001\013\001\014\001\015\001\016\001\017\001\018\001\
\255\255\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\255\255\
\011\001\012\001\013\001\014\001\015\001\016\001\017\001\018\001\
\061\001\255\255\063\001\064\001\065\001\255\255\063\001\068\001\
\255\255\070\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\061\001\255\255\063\001\064\001\065\001\084\001\
\255\255\068\001\255\255\070\001\255\255\072\001\255\255\255\255\
\075\001\076\001\017\001\018\001\255\255\080\001\081\001\082\001\
\083\001\084\001\061\001\255\255\063\001\064\001\065\001\255\255\
\255\255\068\001\255\255\070\001\255\255\072\001\255\255\255\255\
\075\001\076\001\255\255\255\255\018\001\080\001\081\001\082\001\
\083\001\084\001\011\001\012\001\013\001\014\001\015\001\016\001\
\017\001\018\001\255\255\255\255\255\255\255\255\061\001\255\255\
\063\001\064\001\065\001\255\255\255\255\068\001\255\255\070\001\
\255\255\072\001\011\001\012\001\013\001\014\001\015\001\016\001\
\017\001\018\001\255\255\082\001\083\001\084\001\255\255\061\001\
\255\255\063\001\064\001\065\001\255\255\255\255\068\001\255\255\
\070\001\255\255\255\255\255\255\061\001\255\255\063\001\064\001\
\065\001\255\255\255\255\068\001\255\255\070\001\084\001\072\001\
\255\255\255\255\075\001\076\001\017\001\018\001\255\255\080\001\
\081\001\082\001\083\001\084\001\061\001\255\255\063\001\064\001\
\065\001\255\255\255\255\068\001\255\255\070\001\255\255\072\001\
\255\255\255\255\255\255\255\255\255\255\255\255\018\001\080\001\
\081\001\082\001\083\001\084\001\011\001\012\001\013\001\014\001\
\015\001\016\001\017\001\018\001\255\255\255\255\255\255\255\255\
\061\001\255\255\063\001\064\001\065\001\255\255\255\255\068\001\
\255\255\070\001\255\255\072\001\011\001\012\001\013\001\014\001\
\015\001\016\001\017\001\018\001\255\255\082\001\083\001\084\001\
\255\255\061\001\255\255\063\001\064\001\065\001\255\255\255\255\
\068\001\255\255\070\001\255\255\255\255\255\255\061\001\255\255\
\063\001\064\001\065\001\255\255\255\255\068\001\255\255\070\001\
\084\001\072\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\080\001\081\001\082\001\083\001\084\001\061\001\006\001\
\063\001\064\001\065\001\255\255\255\255\068\001\255\255\070\001\
\255\255\072\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\080\001\081\001\082\001\083\001\084\001\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\013\001\014\001\015\001\016\001\017\001\018\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\067\001\068\001\069\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\077\001\013\001\
\014\001\015\001\016\001\017\001\018\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\061\001\255\255\063\001\064\001\065\001\255\255\255\255\
\068\001\255\255\070\001\255\255\072\001\013\001\014\001\015\001\
\016\001\017\001\018\001\255\255\080\001\081\001\082\001\083\001\
\084\001\255\255\255\255\255\255\255\255\255\255\255\255\061\001\
\255\255\063\001\064\001\065\001\255\255\255\255\068\001\255\255\
\070\001\255\255\072\001\013\001\014\001\015\001\016\001\017\001\
\018\001\255\255\080\001\081\001\082\001\083\001\084\001\255\255\
\255\255\255\255\255\255\255\255\255\255\061\001\255\255\063\001\
\064\001\065\001\255\255\255\255\068\001\255\255\070\001\255\255\
\072\001\013\001\014\001\015\001\016\001\017\001\018\001\255\255\
\080\001\081\001\082\001\083\001\084\001\255\255\255\255\255\255\
\255\255\255\255\255\255\061\001\255\255\063\001\064\001\065\001\
\255\255\255\255\068\001\255\255\070\001\255\255\072\001\015\001\
\016\001\017\001\018\001\255\255\255\255\255\255\080\001\081\001\
\082\001\083\001\084\001\255\255\255\255\255\255\255\255\255\255\
\255\255\061\001\255\255\063\001\064\001\065\001\255\255\255\255\
\068\001\255\255\070\001\255\255\072\001\015\001\016\001\017\001\
\018\001\255\255\255\255\255\255\080\001\081\001\082\001\083\001\
\084\001\255\255\255\255\255\255\255\255\061\001\255\255\063\001\
\064\001\065\001\255\255\255\255\068\001\255\255\070\001\255\255\
\072\001\015\001\016\001\017\001\018\001\255\255\255\255\255\255\
\255\255\255\255\082\001\083\001\084\001\255\255\255\255\255\255\
\255\255\255\255\255\255\061\001\255\255\063\001\064\001\065\001\
\255\255\255\255\068\001\255\255\070\001\255\255\072\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\082\001\083\001\084\001\255\255\002\001\255\255\255\255\061\001\
\006\001\063\001\064\001\065\001\255\255\255\255\068\001\255\255\
\070\001\255\255\072\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\082\001\083\001\084\001\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\017\001\018\001\255\255\255\255\255\255\255\255\
\255\255\255\255\017\001\018\001\255\255\255\255\255\255\061\001\
\062\001\255\255\064\001\065\001\066\001\067\001\068\001\069\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\017\001\018\001\255\255\255\255\255\255\255\255\
\255\255\255\255\017\001\018\001\255\255\255\255\061\001\255\255\
\063\001\064\001\065\001\255\255\255\255\068\001\061\001\070\001\
\063\001\064\001\065\001\255\255\255\255\068\001\255\255\070\001\
\255\255\255\255\255\255\082\001\083\001\084\001\255\255\255\255\
\255\255\255\255\255\255\082\001\083\001\084\001\061\001\255\255\
\063\001\064\001\065\001\255\255\255\255\068\001\061\001\070\001\
\063\001\064\001\065\001\255\255\002\001\068\001\255\255\070\001\
\006\001\255\255\255\255\255\255\083\001\084\001\255\255\255\255\
\255\255\255\255\255\255\255\255\083\001\084\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\029\001\
\030\001\031\001\032\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\002\001\255\255\255\255\255\255\006\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\061\001\
\062\001\255\255\064\001\065\001\066\001\255\255\068\001\255\255\
\255\255\255\255\255\255\255\255\255\255\029\001\030\001\031\001\
\032\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\003\001\255\255\255\255\006\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\061\001\062\001\255\255\
\064\001\065\001\066\001\002\001\068\001\255\255\255\255\006\001\
\255\255\255\255\029\001\030\001\031\001\032\001\033\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\255\255\029\001\030\001\
\031\001\032\001\033\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\068\001\006\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\062\001\
\255\255\002\001\255\255\066\001\255\255\006\001\255\255\255\255\
\255\255\029\001\030\001\031\001\032\001\033\001\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\029\001\030\001\031\001\032\001\
\033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\006\001\
\068\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\062\001\006\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\006\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\063\001\255\255\255\255\255\255\255\255\006\001\255\255\255\255\
\029\001\030\001\031\001\032\001\033\001\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\029\001\030\001\031\001\032\001\
\033\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001"

let yynames_const = "\
  SIZEOF\000\
  PTR_OP\000\
  INC_OP\000\
  DEC_OP\000\
  LEFT_OP\000\
  RIGHT_OP\000\
  LE_OP\000\
  GE_OP\000\
  EQ_OP\000\
  NE_OP\000\
  AND_OP\000\
  OR_OP\000\
  MUL_ASSIGN\000\
  DIV_ASSIGN\000\
  MOD_ASSIGN\000\
  ADD_ASSIGN\000\
  SUB_ASSIGN\000\
  LEFT_ASSIGN\000\
  RIGHT_ASSIGN\000\
  AND_ASSIGN\000\
  XOR_ASSIGN\000\
  OR_ASSIGN\000\
  TYPEDEF\000\
  EXTERN\000\
  STATIC\000\
  AUTO\000\
  REGISTER\000\
  CHAR\000\
  SHORT\000\
  INT\000\
  LONG\000\
  SIGNED\000\
  UNSIGNED\000\
  FLOAT\000\
  DOUBLE\000\
  CONST\000\
  VOLATILE\000\
  VOID\000\
  STRUCT\000\
  UNION\000\
  ENUM\000\
  ELLIPSIS\000\
  CASE\000\
  DEFAULT\000\
  IF\000\
  ELSE\000\
  SWITCH\000\
  WHILE\000\
  DO\000\
  FOR\000\
  GOTO\000\
  CONTINUE\000\
  BREAK\000\
  RETURN\000\
  SEMICOLON\000\
  LBRACE\000\
  RBRACE\000\
  COMMA\000\
  COLON\000\
  EQUAL\000\
  LPAR\000\
  RPAR\000\
  LSQUARE\000\
  RSQUARE\000\
  DOT\000\
  AMP\000\
  EXL\000\
  TILDE\000\
  MINUS\000\
  PLUS\000\
  STAR\000\
  SLASH\000\
  PERCENT\000\
  LT\000\
  GT\000\
  HAT\000\
  PIPE\000\
  QUESTION\000\
  EOF\000\
  "

let yynames_block = "\
  ANNOT\000\
  WDECL\000\
  IDENTIFIER\000\
  CONSTANT\000\
  STRING_LITERAL\000\
  TYPE_NAME\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'translation_unit) in
    Obj.repr((
# 71 "src/cparser.mly"
                                 _1 ) : Cast.file))
; (fun parser_env ->
    Obj.repr((
# 72 "src/cparser.mly"
                [] ) : Cast.file))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 76 "src/cparser.mly"
                       CEvar (loc (), Ident.create _1) ) : 'primary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 77 "src/cparser.mly"
                     CEconst (loc (), _1) ) : 'primary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 78 "src/cparser.mly"
                           uns() ) : 'primary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 79 "src/cparser.mly"
                                 _2 ) : 'primary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'primary_expression) in
    Obj.repr((
# 84 "src/cparser.mly"
              _1 ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'postfix_expression) in
    let _3 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 86 "src/cparser.mly"
       CEarrget (loc (), _1, _3) ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'postfix_expression) in
    Obj.repr((
# 88 "src/cparser.mly"
       CEcall (loc (), _1, []) ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'postfix_expression) in
    let _3 = (peek_val parser_env 1 : 'argument_expression_list) in
    Obj.repr((
# 90 "src/cparser.mly"
       CEcall (loc (), _1, _3) ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'postfix_expression) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 92 "src/cparser.mly"
       uns () ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'postfix_expression) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 94 "src/cparser.mly"
       uns() ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'postfix_expression) in
    Obj.repr((
# 96 "src/cparser.mly"
       CEunary (loc (), Postfix_inc, _1) ) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'postfix_expression) in
    Obj.repr((
# 98 "src/cparser.mly"
       CEunary (loc (), Postfix_dec, _1)) : 'postfix_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 102 "src/cparser.mly"
                                  [_1] ) : 'argument_expression_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'argument_expression_list) in
    let _3 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 103 "src/cparser.mly"
                                                                 _1 @ [_3] ) : 'argument_expression_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'postfix_expression) in
    Obj.repr((
# 107 "src/cparser.mly"
                               _1 ) : 'unary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 108 "src/cparser.mly"
                                    CEunary (loc (), Prefix_inc, _2) ) : 'unary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 109 "src/cparser.mly"
                                    CEunary (loc (), Prefix_dec, _2) ) : 'unary_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'unary_operator) in
    let _2 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 110 "src/cparser.mly"
                                           CEunary (loc (), _1, _2) ) : 'unary_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 111 "src/cparser.mly"
                                    uns () ) : 'unary_expression))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'type_name) in
    Obj.repr((
# 112 "src/cparser.mly"
                                       uns () ) : 'unary_expression))
; (fun parser_env ->
    Obj.repr((
# 116 "src/cparser.mly"
                Uamp ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 117 "src/cparser.mly"
                 Ustar ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 118 "src/cparser.mly"
                 Uplus ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 119 "src/cparser.mly"
                  Uminus ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 120 "src/cparser.mly"
                  uns () ) : 'unary_operator))
; (fun parser_env ->
    Obj.repr((
# 121 "src/cparser.mly"
                Not ) : 'unary_operator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'unary_expression) in
    Obj.repr((
# 125 "src/cparser.mly"
                             _1 ) : 'cast_expression))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'type_name) in
    let _4 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 126 "src/cparser.mly"
                                                uns () ) : 'cast_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 131 "src/cparser.mly"
              _1 ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'multiplicative_expression) in
    let _3 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 133 "src/cparser.mly"
       CEbinary (loc (), _1, Mult, _3) ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'multiplicative_expression) in
    let _3 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 135 "src/cparser.mly"
       CEbinary (loc (), _1, Div, _3) ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'multiplicative_expression) in
    let _3 = (peek_val parser_env 0 : 'cast_expression) in
    Obj.repr((
# 137 "src/cparser.mly"
       CEbinary (loc (), _1, Mod, _3) ) : 'multiplicative_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'multiplicative_expression) in
    Obj.repr((
# 142 "src/cparser.mly"
             _1 ) : 'additive_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'additive_expression) in
    let _3 = (peek_val parser_env 0 : 'multiplicative_expression) in
    Obj.repr((
# 144 "src/cparser.mly"
       CEbinary (loc (), _1, Plus, _3) ) : 'additive_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'additive_expression) in
    let _3 = (peek_val parser_env 0 : 'multiplicative_expression) in
    Obj.repr((
# 146 "src/cparser.mly"
       CEbinary (loc (), _1, Minus, _3) ) : 'additive_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'additive_expression) in
    Obj.repr((
# 150 "src/cparser.mly"
                                _1 ) : 'shift_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'shift_expression) in
    let _3 = (peek_val parser_env 0 : 'additive_expression) in
    Obj.repr((
# 151 "src/cparser.mly"
                                                         uns () ) : 'shift_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'shift_expression) in
    let _3 = (peek_val parser_env 0 : 'additive_expression) in
    Obj.repr((
# 152 "src/cparser.mly"
                                                          uns () ) : 'shift_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 157 "src/cparser.mly"
              _1 ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 159 "src/cparser.mly"
       CEbinary (loc (), _1, Lt, _3) ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 161 "src/cparser.mly"
       CEbinary (loc (), _1, Gt, _3) ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 163 "src/cparser.mly"
       CEbinary (loc (), _1, Le, _3) ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'relational_expression) in
    let _3 = (peek_val parser_env 0 : 'shift_expression) in
    Obj.repr((
# 165 "src/cparser.mly"
       CEbinary (loc (), _1, Ge, _3) ) : 'relational_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'relational_expression) in
    Obj.repr((
# 170 "src/cparser.mly"
              _1 ) : 'equality_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'equality_expression) in
    let _3 = (peek_val parser_env 0 : 'relational_expression) in
    Obj.repr((
# 172 "src/cparser.mly"
       CEbinary (loc (), _1, Eq, _3) ) : 'equality_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'equality_expression) in
    let _3 = (peek_val parser_env 0 : 'relational_expression) in
    Obj.repr((
# 174 "src/cparser.mly"
       CEbinary (loc (), _1, Neq, _3) ) : 'equality_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'equality_expression) in
    Obj.repr((
# 179 "src/cparser.mly"
              _1 ) : 'and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'and_expression) in
    let _3 = (peek_val parser_env 0 : 'equality_expression) in
    Obj.repr((
# 181 "src/cparser.mly"
       CEbinary (loc (), _1, Bw_and, _3) ) : 'and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'and_expression) in
    Obj.repr((
# 186 "src/cparser.mly"
              _1 ) : 'exclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'exclusive_or_expression) in
    let _3 = (peek_val parser_env 0 : 'and_expression) in
    Obj.repr((
# 188 "src/cparser.mly"
       CEbinary (loc (), _1, Bw_xor, _3) ) : 'exclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'exclusive_or_expression) in
    Obj.repr((
# 193 "src/cparser.mly"
              _1 ) : 'inclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'inclusive_or_expression) in
    let _3 = (peek_val parser_env 0 : 'exclusive_or_expression) in
    Obj.repr((
# 195 "src/cparser.mly"
       CEbinary (loc (), _1, Bw_or, _3) ) : 'inclusive_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'inclusive_or_expression) in
    Obj.repr((
# 200 "src/cparser.mly"
              _1 ) : 'logical_and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'logical_and_expression) in
    let _3 = (peek_val parser_env 0 : 'inclusive_or_expression) in
    Obj.repr((
# 202 "src/cparser.mly"
       CEbinary (loc (), _1, And, _3) ) : 'logical_and_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'logical_and_expression) in
    Obj.repr((
# 207 "src/cparser.mly"
              _1 ) : 'logical_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'logical_or_expression) in
    let _3 = (peek_val parser_env 0 : 'logical_and_expression) in
    Obj.repr((
# 209 "src/cparser.mly"
       CEbinary (loc (), _1, Or, _3) ) : 'logical_or_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'logical_or_expression) in
    Obj.repr((
# 214 "src/cparser.mly"
              _1 ) : 'conditional_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'logical_or_expression) in
    let _3 = (peek_val parser_env 2 : 'expression) in
    let _5 = (peek_val parser_env 0 : 'conditional_expression) in
    Obj.repr((
# 216 "src/cparser.mly"
       CEcond (loc (), _1, _3, _5) ) : 'conditional_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'conditional_expression) in
    Obj.repr((
# 221 "src/cparser.mly"
              _1 ) : 'assignment_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'unary_expression) in
    let _2 = (peek_val parser_env 1 : 'assignment_operator) in
    let _3 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 223 "src/cparser.mly"
       CEassign (loc (), _1, _2, _3) ) : 'assignment_expression))
; (fun parser_env ->
    Obj.repr((
# 227 "src/cparser.mly"
                  Aequal ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 228 "src/cparser.mly"
                       Amul ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 229 "src/cparser.mly"
                       Adiv ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 230 "src/cparser.mly"
                       Amod ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 231 "src/cparser.mly"
                       Aadd ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 232 "src/cparser.mly"
                       Asub ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 233 "src/cparser.mly"
                        Aleft ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 234 "src/cparser.mly"
                         Aright ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 235 "src/cparser.mly"
                       Aand ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 236 "src/cparser.mly"
                       Axor ) : 'assignment_operator))
; (fun parser_env ->
    Obj.repr((
# 237 "src/cparser.mly"
                      Aor ) : 'assignment_operator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 241 "src/cparser.mly"
                                  _1 ) : 'expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'expression) in
    let _3 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 242 "src/cparser.mly"
                                                   CEseq (loc(), _1, _3) ) : 'expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'conditional_expression) in
    Obj.repr((
# 246 "src/cparser.mly"
                                   _1 ) : 'constant_expression))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_specifiers) in
    Obj.repr((
# 250 "src/cparser.mly"
                                             uns() ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 1 : 'init_declarator_list) in
    Obj.repr((
# 252 "src/cparser.mly"
       List.map (fun (p,d) -> 
			  let v = if p then CTpointer _1 else _1 in
			  Ctypedecl (loc(), d, v)) _2 ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : int * string) in
    Obj.repr((
# 255 "src/cparser.mly"
           [Cspecdecl _1] ) : 'declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'storage_class_specifier) in
    Obj.repr((
# 259 "src/cparser.mly"
                                    uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'storage_class_specifier) in
    let _2 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 260 "src/cparser.mly"
                                                           uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_specifier) in
    Obj.repr((
# 261 "src/cparser.mly"
                           _1 ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_specifier) in
    let _2 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 262 "src/cparser.mly"
                                                  uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 263 "src/cparser.mly"
                           uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_qualifier) in
    let _2 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 264 "src/cparser.mly"
                                                  uns() ) : 'declaration_specifiers))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'init_declarator) in
    Obj.repr((
# 268 "src/cparser.mly"
                            [_1] ) : 'init_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'init_declarator_list) in
    let _3 = (peek_val parser_env 0 : 'init_declarator) in
    Obj.repr((
# 269 "src/cparser.mly"
                                                       _1 @ [_3] ) : 'init_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declarator) in
    Obj.repr((
# 274 "src/cparser.mly"
              _1 ) : 'init_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declarator) in
    let _3 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr((
# 276 "src/cparser.mly"
       match _1 with 
		| p, CDvar (id, _) -> p, CDvar (id, Some _3) 
		| d -> d 
	    ) : 'init_declarator))
; (fun parser_env ->
    Obj.repr((
# 283 "src/cparser.mly"
                    ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 284 "src/cparser.mly"
                   ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 285 "src/cparser.mly"
                   ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 286 "src/cparser.mly"
                 ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 287 "src/cparser.mly"
                     ) : 'storage_class_specifier))
; (fun parser_env ->
    Obj.repr((
# 291 "src/cparser.mly"
                 CTpure PTunit ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 292 "src/cparser.mly"
                 CTpure PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 293 "src/cparser.mly"
                  CTpure PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 294 "src/cparser.mly"
                CTpure PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 295 "src/cparser.mly"
                 CTpure PTint ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 296 "src/cparser.mly"
                  CTpure PTfloat ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 297 "src/cparser.mly"
                   CTpure PTfloat ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 298 "src/cparser.mly"
                   uns() ) : 'type_specifier))
; (fun parser_env ->
    Obj.repr((
# 299 "src/cparser.mly"
                     uns() ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'struct_or_union_specifier) in
    Obj.repr((
# 300 "src/cparser.mly"
                                      uns() ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'enum_specifier) in
    Obj.repr((
# 301 "src/cparser.mly"
                           uns() ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 302 "src/cparser.mly"
                      CTpure (PTexternal (Ident.create _1)) ) : 'type_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'struct_or_union) in
    let _2 = (peek_val parser_env 3 : string) in
    let _4 = (peek_val parser_env 1 : 'struct_declaration_list) in
    Obj.repr((
# 306 "src/cparser.mly"
                                                                             ) : 'struct_or_union_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'struct_or_union) in
    let _3 = (peek_val parser_env 1 : 'struct_declaration_list) in
    Obj.repr((
# 307 "src/cparser.mly"
                                                                  ) : 'struct_or_union_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'struct_or_union) in
    let _2 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 308 "src/cparser.mly"
                                       ) : 'struct_or_union_specifier))
; (fun parser_env ->
    Obj.repr((
# 312 "src/cparser.mly"
                   ) : 'struct_or_union))
; (fun parser_env ->
    Obj.repr((
# 313 "src/cparser.mly"
                  ) : 'struct_or_union))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'struct_declaration) in
    Obj.repr((
# 317 "src/cparser.mly"
                               ) : 'struct_declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'struct_declaration_list) in
    let _2 = (peek_val parser_env 0 : 'struct_declaration) in
    Obj.repr((
# 318 "src/cparser.mly"
                                                       ) : 'struct_declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'specifier_qualifier_list) in
    let _2 = (peek_val parser_env 1 : 'struct_declarator_list) in
    Obj.repr((
# 322 "src/cparser.mly"
                                                                      ) : 'struct_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_specifier) in
    let _2 = (peek_val parser_env 0 : 'specifier_qualifier_list) in
    Obj.repr((
# 326 "src/cparser.mly"
                                                    ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_specifier) in
    Obj.repr((
# 327 "src/cparser.mly"
                           ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_qualifier) in
    let _2 = (peek_val parser_env 0 : 'specifier_qualifier_list) in
    Obj.repr((
# 328 "src/cparser.mly"
                                                    ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 329 "src/cparser.mly"
                           ) : 'specifier_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'struct_declarator) in
    Obj.repr((
# 333 "src/cparser.mly"
                              ) : 'struct_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'struct_declarator_list) in
    let _3 = (peek_val parser_env 0 : 'struct_declarator) in
    Obj.repr((
# 334 "src/cparser.mly"
                                                           ) : 'struct_declarator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declarator) in
    Obj.repr((
# 338 "src/cparser.mly"
                       ) : 'struct_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'constant_expression) in
    Obj.repr((
# 339 "src/cparser.mly"
                                      ) : 'struct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declarator) in
    let _3 = (peek_val parser_env 0 : 'constant_expression) in
    Obj.repr((
# 340 "src/cparser.mly"
                                                 ) : 'struct_declarator))
; (fun parser_env ->
    let _3 = (peek_val parser_env 1 : 'enumerator_list) in
    Obj.repr((
# 344 "src/cparser.mly"
                                               ) : 'enum_specifier))
; (fun parser_env ->
    let _2 = (peek_val parser_env 3 : string) in
    let _4 = (peek_val parser_env 1 : 'enumerator_list) in
    Obj.repr((
# 345 "src/cparser.mly"
                                                          ) : 'enum_specifier))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 346 "src/cparser.mly"
                            ) : 'enum_specifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'enumerator) in
    Obj.repr((
# 350 "src/cparser.mly"
                       ) : 'enumerator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'enumerator_list) in
    let _3 = (peek_val parser_env 0 : 'enumerator) in
    Obj.repr((
# 351 "src/cparser.mly"
                                             ) : 'enumerator_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 355 "src/cparser.mly"
                       ) : 'enumerator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : string) in
    let _3 = (peek_val parser_env 0 : 'constant_expression) in
    Obj.repr((
# 356 "src/cparser.mly"
                                                 ) : 'enumerator))
; (fun parser_env ->
    Obj.repr((
# 360 "src/cparser.mly"
                  ) : 'type_qualifier))
; (fun parser_env ->
    Obj.repr((
# 361 "src/cparser.mly"
                     ) : 'type_qualifier))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'pointer) in
    let _2 = (peek_val parser_env 0 : 'direct_declarator) in
    Obj.repr((
# 365 "src/cparser.mly"
                                      true, _2 ) : 'declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'direct_declarator) in
    Obj.repr((
# 366 "src/cparser.mly"
                              false, _1 ) : 'declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 371 "src/cparser.mly"
              CDvar (Ident.create _1, None) ) : 'direct_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'declarator) in
    Obj.repr((
# 373 "src/cparser.mly"
       uns() ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_declarator) in
    let _3 = (peek_val parser_env 1 : 'constant_expression) in
    Obj.repr((
# 375 "src/cparser.mly"
       uns() ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'direct_declarator) in
    Obj.repr((
# 377 "src/cparser.mly"
       match _1 with CDvar (id,_) -> CDarr (id, None) | _ -> uns () ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 4 : 'direct_declarator) in
    let _3 = (peek_val parser_env 2 : 'parameter_type_list) in
    let _5 = (peek_val parser_env 0 : 'annot) in
    Obj.repr((
# 379 "src/cparser.mly"
       match _1 with CDvar (id,_) -> CDfun (id, _3, _5) | _ -> uns () ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_declarator) in
    let _3 = (peek_val parser_env 1 : 'identifier_list) in
    Obj.repr((
# 381 "src/cparser.mly"
       uns() ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_declarator) in
    let _4 = (peek_val parser_env 0 : 'annot) in
    Obj.repr((
# 383 "src/cparser.mly"
              match _1 with CDvar (id,_) -> CDfun (id, [], _4) | _ -> uns () ) : 'direct_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : int * string) in
    Obj.repr((
# 388 "src/cparser.mly"
                          Some _1 ) : 'annot))
; (fun parser_env ->
    Obj.repr((
# 389 "src/cparser.mly"
                          None ) : 'annot))
; (fun parser_env ->
    Obj.repr((
# 393 "src/cparser.mly"
                 () ) : 'pointer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'type_qualifier_list) in
    Obj.repr((
# 394 "src/cparser.mly"
                                     uns () ) : 'pointer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 0 : 'pointer) in
    Obj.repr((
# 395 "src/cparser.mly"
                         uns () ) : 'pointer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'type_qualifier_list) in
    let _3 = (peek_val parser_env 0 : 'pointer) in
    Obj.repr((
# 396 "src/cparser.mly"
                                             uns () ) : 'pointer))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 400 "src/cparser.mly"
                           ) : 'type_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'type_qualifier_list) in
    let _2 = (peek_val parser_env 0 : 'type_qualifier) in
    Obj.repr((
# 401 "src/cparser.mly"
                                               ) : 'type_qualifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'parameter_list) in
    Obj.repr((
# 406 "src/cparser.mly"
                           _1 ) : 'parameter_type_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'parameter_list) in
    Obj.repr((
# 407 "src/cparser.mly"
                                          uns() ) : 'parameter_type_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'parameter_declaration) in
    Obj.repr((
# 411 "src/cparser.mly"
                                  [_1] ) : 'parameter_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'parameter_list) in
    let _3 = (peek_val parser_env 0 : 'parameter_declaration) in
    Obj.repr((
# 412 "src/cparser.mly"
                                                       _1 @ [_3] ) : 'parameter_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 0 : 'declarator) in
    Obj.repr((
# 417 "src/cparser.mly"
              match _2 with 
		| false, CDvar (id, _) -> _1, id 
		| true, CDvar (id, _) -> CTpointer _1, id 
		| false, CDarr (id, _) -> CTarray _1, id
		| _ -> uns() ) : 'parameter_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 0 : 'abstract_declarator) in
    Obj.repr((
# 422 "src/cparser.mly"
                                                       uns() ) : 'parameter_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declaration_specifiers) in
    Obj.repr((
# 423 "src/cparser.mly"
                                   (_1, Ident.anonymous) ) : 'parameter_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 427 "src/cparser.mly"
                       ) : 'identifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'identifier_list) in
    let _3 = (peek_val parser_env 0 : string) in
    Obj.repr((
# 428 "src/cparser.mly"
                                             ) : 'identifier_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'specifier_qualifier_list) in
    Obj.repr((
# 432 "src/cparser.mly"
                                     ) : 'type_name))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'specifier_qualifier_list) in
    let _2 = (peek_val parser_env 0 : 'abstract_declarator) in
    Obj.repr((
# 433 "src/cparser.mly"
                                                         ) : 'type_name))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'pointer) in
    Obj.repr((
# 437 "src/cparser.mly"
                    ) : 'abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr((
# 438 "src/cparser.mly"
                                       ) : 'abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'pointer) in
    let _2 = (peek_val parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr((
# 439 "src/cparser.mly"
                                               ) : 'abstract_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'abstract_declarator) in
    Obj.repr((
# 443 "src/cparser.mly"
                                          ) : 'direct_abstract_declarator))
; (fun parser_env ->
    Obj.repr((
# 444 "src/cparser.mly"
                            ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'constant_expression) in
    Obj.repr((
# 445 "src/cparser.mly"
                                                ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'direct_abstract_declarator) in
    Obj.repr((
# 446 "src/cparser.mly"
                                                       ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_abstract_declarator) in
    let _3 = (peek_val parser_env 1 : 'constant_expression) in
    Obj.repr((
# 447 "src/cparser.mly"
                                                                           ) : 'direct_abstract_declarator))
; (fun parser_env ->
    Obj.repr((
# 448 "src/cparser.mly"
                      ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'parameter_type_list) in
    Obj.repr((
# 449 "src/cparser.mly"
                                          ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'direct_abstract_declarator) in
    Obj.repr((
# 450 "src/cparser.mly"
                                                 ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'direct_abstract_declarator) in
    let _3 = (peek_val parser_env 1 : 'parameter_type_list) in
    Obj.repr((
# 451 "src/cparser.mly"
                                                                     ) : 'direct_abstract_declarator))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'assignment_expression) in
    Obj.repr((
# 455 "src/cparser.mly"
                                  _1 ) : 'c_initializer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'c_initializer_list) in
    Obj.repr((
# 456 "src/cparser.mly"
                                             uns() ) : 'c_initializer))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'c_initializer_list) in
    Obj.repr((
# 457 "src/cparser.mly"
                                                   uns() ) : 'c_initializer))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr((
# 461 "src/cparser.mly"
                          ) : 'c_initializer_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'c_initializer_list) in
    let _3 = (peek_val parser_env 0 : 'c_initializer) in
    Obj.repr((
# 462 "src/cparser.mly"
                                                   ) : 'c_initializer_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'labeled_statement) in
    Obj.repr((
# 466 "src/cparser.mly"
                              _1 ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 467 "src/cparser.mly"
                               CSblock (loc (), _1) ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'expression_statement) in
    Obj.repr((
# 468 "src/cparser.mly"
                                 _1 ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'selection_statement) in
    Obj.repr((
# 469 "src/cparser.mly"
                                _1 ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'iteration_statement) in
    Obj.repr((
# 470 "src/cparser.mly"
                                _1 ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'jump_statement) in
    Obj.repr((
# 471 "src/cparser.mly"
                           _1 ) : 'statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : string) in
    let _3 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 475 "src/cparser.mly"
                                       uns () ) : 'labeled_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'constant_expression) in
    let _4 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 476 "src/cparser.mly"
                                                     uns () ) : 'labeled_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 477 "src/cparser.mly"
                                    uns () ) : 'labeled_statement))
; (fun parser_env ->
    Obj.repr((
# 481 "src/cparser.mly"
                          [], [] ) : 'compound_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'statement_list) in
    Obj.repr((
# 482 "src/cparser.mly"
                                         [], _2 ) : 'compound_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'declaration_list) in
    Obj.repr((
# 483 "src/cparser.mly"
                                           _2, [] ) : 'compound_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 2 : 'declaration_list) in
    let _3 = (peek_val parser_env 1 : 'statement_list) in
    Obj.repr((
# 484 "src/cparser.mly"
                                                          _2, _3 ) : 'compound_statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'compound_statement) in
    let _2 = (peek_val parser_env 0 : 'annot) in
    Obj.repr((
# 489 "src/cparser.mly"
                                     (loc (), _1, _2) ) : 'compound_statement_with_post))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declaration) in
    Obj.repr((
# 493 "src/cparser.mly"
                        _1 ) : 'declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declaration_list) in
    let _2 = (peek_val parser_env 0 : 'declaration) in
    Obj.repr((
# 494 "src/cparser.mly"
                                         _1 @ _2 ) : 'declaration_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 498 "src/cparser.mly"
                      [_1] ) : 'statement_list))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'statement_list) in
    let _2 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 499 "src/cparser.mly"
                                     _1 @ [_2] ) : 'statement_list))
; (fun parser_env ->
    Obj.repr((
# 503 "src/cparser.mly"
                      CSnop (loc ()) ) : 'expression_statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 504 "src/cparser.mly"
                                 CSexpr (loc (), _1) ) : 'expression_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 2 : 'expression) in
    let _5 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 509 "src/cparser.mly"
              CScond (loc (), _3, _5, CSnop (loc ())) ) : 'selection_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 4 : 'expression) in
    let _5 = (peek_val parser_env 2 : 'statement) in
    let _7 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 511 "src/cparser.mly"
       CScond (loc (), _3, _5, _7) ) : 'selection_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 2 : 'expression) in
    let _5 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 513 "src/cparser.mly"
       uns () ) : 'selection_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 3 : 'expression) in
    let _5 = (peek_val parser_env 1 : int * string) in
    let _6 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 518 "src/cparser.mly"
              CSwhile (loc (), _3, _5, _6) ) : 'iteration_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 6 : 'statement) in
    let _3 = (peek_val parser_env 5 : int * string) in
    let _6 = (peek_val parser_env 2 : 'expression) in
    Obj.repr((
# 520 "src/cparser.mly"
       CSdowhile (loc (), _2, _3, _6) ) : 'iteration_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 4 : 'expression_statement) in
    let _4 = (peek_val parser_env 3 : 'expression_statement) in
    let _6 = (peek_val parser_env 1 : int * string) in
    let _7 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 522 "src/cparser.mly"
       CSfor (loc (), expr_of_statement _3, expr_of_statement _4, 
		     None, _6, _7) ) : 'iteration_statement))
; (fun parser_env ->
    let _3 = (peek_val parser_env 5 : 'expression_statement) in
    let _4 = (peek_val parser_env 4 : 'expression_statement) in
    let _5 = (peek_val parser_env 3 : 'expression) in
    let _7 = (peek_val parser_env 1 : int * string) in
    let _8 = (peek_val parser_env 0 : 'statement) in
    Obj.repr((
# 525 "src/cparser.mly"
       CSfor (loc (), expr_of_statement _3, expr_of_statement _4, 
		     Some _5, _7, _8) ) : 'iteration_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : string) in
    Obj.repr((
# 530 "src/cparser.mly"
                                      uns () ) : 'jump_statement))
; (fun parser_env ->
    Obj.repr((
# 531 "src/cparser.mly"
                               CScontinue (loc ()) ) : 'jump_statement))
; (fun parser_env ->
    Obj.repr((
# 532 "src/cparser.mly"
                            CSbreak (loc ()) ) : 'jump_statement))
; (fun parser_env ->
    Obj.repr((
# 533 "src/cparser.mly"
                             CSreturn (loc (), None) ) : 'jump_statement))
; (fun parser_env ->
    let _2 = (peek_val parser_env 1 : 'expression) in
    Obj.repr((
# 534 "src/cparser.mly"
                                        CSreturn (loc (), Some _2) ) : 'jump_statement))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'external_declaration) in
    Obj.repr((
# 538 "src/cparser.mly"
                                 _1 ) : 'translation_unit))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'translation_unit) in
    let _2 = (peek_val parser_env 0 : 'external_declaration) in
    Obj.repr((
# 539 "src/cparser.mly"
                                                  _1 @ _2 ) : 'translation_unit))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'function_definition) in
    Obj.repr((
# 543 "src/cparser.mly"
                                [_1] ) : 'external_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 0 : 'declaration) in
    Obj.repr((
# 544 "src/cparser.mly"
                        _1 ) : 'external_declaration))
; (fun parser_env ->
    let _1 = (peek_val parser_env 3 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 2 : 'declarator) in
    let _3 = (peek_val parser_env 1 : 'declaration_list) in
    let _4 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 549 "src/cparser.mly"
              uns () ) : 'function_definition))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declaration_specifiers) in
    let _2 = (peek_val parser_env 1 : 'declarator) in
    let _3 = (peek_val parser_env 0 : 'compound_statement_with_post) in
    Obj.repr((
# 551 "src/cparser.mly"
       let (lb,b,q) = _3 in
              match _2 with
		| false, CDfun (id, pl, p) -> 
		    let lb = add_pre_loc lb p in
		    Cfundef (loc (), id, pl, _1, (lb,p,b,q))
		| _ -> uns () ) : 'function_definition))
; (fun parser_env ->
    let _1 = (peek_val parser_env 2 : 'declarator) in
    let _2 = (peek_val parser_env 1 : 'declaration_list) in
    let _3 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 558 "src/cparser.mly"
       uns () ) : 'function_definition))
; (fun parser_env ->
    let _1 = (peek_val parser_env 1 : 'declarator) in
    let _2 = (peek_val parser_env 0 : 'compound_statement) in
    Obj.repr((
# 560 "src/cparser.mly"
       uns () ) : 'function_definition))
(* Entry file *)
; (fun parser_env -> raise (YYexit (peek_val parser_env 0)))
|]
let yytables =
  { actions=yyact;
    transl_const=yytransl_const;
    transl_block=yytransl_block;
    lhs=yylhs;
    len=yylen;
    defred=yydefred;
    dgoto=yydgoto;
    sindex=yysindex;
    rindex=yyrindex;
    gindex=yygindex;
    tablesize=yytablesize;
    table=yytable;
    check=yycheck;
    error_function=parse_error;
    names_const=yynames_const;
    names_block=yynames_block }
let file (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (yyparse yytables 1 lexfun lexbuf : Cast.file)
